
#include <stdio.h>
#include <wchar.h>
#include <stdio.h>
#include <windows.h>

const WCHAR ClassName[] = L"Gerber3D_WindowClass";


int main(int argc, WCHAR * argv[])
{
	HWND  hwDispatch=NULL;
	COPYDATASTRUCT cpyDat;
	WCHAR inbuf[2048];
	char searchbuf[2048];
	int res;
	char *ppin;
	wprintf(L"<empty>             - exit program\n");
	wprintf(L"Q                   - exit program\n");
	wprintf(L"C                   - connect to ZofzPCB Gerber3D_WindowClass\n");
	wprintf(L"L <path>            - Load PCB from \"path\" preferable .zofzproj\n");
	wprintf(L"j <component>       - jump to component\n");
	wprintf(L"j <component>,<pin> - jump to component and pin\n");
	wprintf(L"n <netname>         - show net\n");
	while(1)
	{
		wprintf(L"->");
		_getws_s(inbuf);
		WCHAR * rp = inbuf;
		while(*rp && *rp<=' ') rp++;
		switch(*rp++) {
		case 0: 
		case 'q':
		case 'Q':
			return 0;

		case 'c': 
		case 'C': 
			hwDispatch = FindWindow( L"Gerber3D_WindowClass", NULL );
			GetWindowText(hwDispatch, inbuf, _countof(inbuf));
			wprintf(L"connect to window %u - %s\n", hwDispatch, inbuf);
			break;

		case 'l':
		case 'L':  // load <widechar path> (preferable .zofzproj)
			while(*rp && *rp<=' ') rp++;
			cpyDat.dwData = 'load';
			cpyDat.cbData = (wcslen(rp)+1)*sizeof(WCHAR);
			cpyDat.lpData = rp; // zero delimited, zero included
			res = SendMessage(hwDispatch, WM_COPYDATA, (WPARAM)GetConsoleWindow(), (LPARAM)&cpyDat );
			wprintf(L"send open res=%i\n", res);
			break;

		case 'j':
		case 'J':
			while(*rp && *rp<=' ') rp++;
			cpyDat.dwData = 'jump';
			res = sprintf_s(searchbuf, "%S", rp);
			ppin = strchr(searchbuf, ',');
			if(ppin) *ppin=0;
			cpyDat.lpData = searchbuf;
			cpyDat.cbData = res+1;
			res = SendMessage(hwDispatch, WM_COPYDATA, (WPARAM)GetConsoleWindow(), (LPARAM)&cpyDat );
			wprintf(L"send jump res=%i\n", res);
			break;

		case 'n':
		case 'N':
			while(*rp && *rp<=' ') rp++;
			cpyDat.dwData = 'net';
			res = sprintf_s(searchbuf, "%S", rp);
			cpyDat.lpData = searchbuf;
			cpyDat.cbData = res+1;
			res = SendMessage(hwDispatch, WM_COPYDATA, (WPARAM)GetConsoleWindow(), (LPARAM)&cpyDat );
			wprintf(L"send net res=%i\n", res);
			break;

		}
	}
	
	return 0;
}

